import java.applet.Applet;
import java.awt.*;

class GraphicCanvas extends Canvas {
  Dimension size;                                                // kvnt mret
  Font font;                                               // hasznlt bettpus
  String label;                                         // megjelentend szveg
  FontMetrics fm;                                         // bettpus jellemzi

  public GraphicCanvas(String label, int width, int height) {
    super();
    size=new Dimension(width, height);
    this.label=label;
    font=new Font("TimesRoman", Font.BOLD+Font.ITALIC, 20);
    fm=getFontMetrics(font);                           // bettpus elksztse
  }

  public Dimension preferredSize() {
    return size;
  }

  public void paint(Graphics g) {                       // ellipszis kirajzolsa
    g.fillOval(0, 0, size.width-1, size.height-1);
    g.setColor(getBackground());
    g.setFont(font);                                           // szveg kirsa
    g.drawString(label, size.width/2 - fm.stringWidth(label)/2,
                        size.height/2 + fm.getMaxDescent());
  }
}

public class CanvasTest extends Applet {
  public void init() {                                // tesztfellet felptse
    GraphicCanvas gc=new GraphicCanvas("Java", 80, 100);
    gc.setForeground(SystemColor.textHighlightText);
    gc.setBackground(SystemColor.textHighlight);
    add(gc);
    gc=new GraphicCanvas("rules!", 100, 50);
    gc.setForeground(Color.red);
    gc.setBackground(Color.white);
    add(gc);
    validate();
  }
}
