//////////////////////////////////////////////////////////////////
// Egy egyszer bean, ami egy megvltoztathat szmot tartalmaz //
//////////////////////////////////////////////////////////////////
// Csomag a bean trolshoz
package demo.number;
import java.awt.*;		
import java.util.EventObject;
import java.beans.*;

public class NumberBean extends Canvas {
  // A bean lnyegi tulajdonsga, a szm
  int number = 10;

  // Konstruktor. Ebben csak a sznek belltsa trtnik
  public NumberBean() {
        setBackground(Color.white);
        setForeground(Color.black);
  }
  // A szm lekrdezse a kontneren keresztl
  public synchronized int getNumber() {
        return number;
  } 
  // Megjelents
  public void paint(Graphics g) {
        g.drawString("["+number+"]",10,10);
  }
  // A bean minimlis mrete
  public Dimension getMinimumSize() {
        return new Dimension(100,100);
  }
  // A bean ajnlott mrete 
  public Dimension getPreferredSize() {
        return new Dimension(100,100);
  }
  // Objektum a szm megvltozsnak jelentsre
  private PropertyChangeSupport changes = 
                                new PropertyChangeSupport(this);
  // A szm lltsa a kontneren keresztl
  public synchronized void setNumber(int newNumber) {
        int oldNumber = number;
        number = newNumber;
        repaint();		// jelentsk is meg mindjrt
        // jelezzk, hogy vltozs trtnt
        changes.firePropertyChange("number",
                                   new Integer(oldNumber),
                                   new Integer(number));
  }
  // A szm belltsa, egy msik bean tulajdonsgvltozsa
  // alapjn. Ennek segtsgvel hangoljuk ssze a szm-bean-eket
  public synchronized void adjustNumber(PropertyChangeEvent e) {
        Integer i =  (Integer) e.getNewValue();
        setNumber(i.intValue());
  }
  // Esemny hatsra megnveljk a szmot
  public synchronized void incNumber(EventObject x) {
        number++;
        repaint();			// jelentsk is meg mindjrt
        // jelezzk, hogy vltozs trtnt
        changes.firePropertyChange("number",
                                   new Integer(number-1),
                                   new Integer(number));
  }
  // Esemny hatsra cskkentjk a szmot
  public synchronized void decNumber(EventObject x) {
        number--;
        repaint();			// jelentsk is meg mindjrt

        // jelezzk, hogy vltozs trtnt
        changes.firePropertyChange("number",
                                   new Integer(number+1),
                                   new Integer(number));
  }
  // Ez a metdus tartja nyilvn a tulajdonsgvltozs jelentsvel
  // foglalkoz objektumokat. Ezt a metdust hvja meg a kontner, 
  // ha egy j objektumot kapcsolnak az esemnyhez.
  public synchronized void addPropertyChangeListener(PropertyChangeListener l) {
        changes.addPropertyChangeListener(l);
  }
  // Ez a metdus tartja nyilvn a tulajdonsgvltozs jelentsvel
  // foglalkoz objektumokat. Ezt a metdust hvja meg a kontner, 
  // ha megszntetnk egy kapcsolatot.
public synchronized void removePropertyChangeListener(PropertyChangeListener l){
        changes.removePropertyChangeListener(l);
  }
}
