import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class PaintTest extends Applet implements MouseListener {
  String text;                                         //aktulis lthat kirs
  String inText;                                  //szveg, ha a kurzor bent van
  String outText;                                 //szveg, ha a kurzor kint van
  Image background;                                                  //httrkp
  Image imageBuffer;                                             //offScreen kp
  Graphics graphicsBuffer;                           //s annak grafikus buffere
  boolean noUpdate;                        //igaz, ha nem kell az eredeti update
  boolean offScreen;                    //igaz, ha offScreen trtnik a rajzols

  public String[][] getParameterInfo() {                   //paramterekrl inf
    String info[][]={
       {"inText", "String", "Bent kirand szveg"},
       {"outText", "String", "Kint kirand szveg"},
       {"background", "Kpfjlnv", "Httrkp"},
       {"noUpdate", "boolean", "Nincs update"},
       {"offScreen", "boolean", "Offscreen rajzols"}};
    return info;
  }
  public String getAppletInfo() {                      //az appletrl informci
    return "Ezen applet a paint() hasznlatt szemllteti";
  }
  public void init(){                                    //kezdeti inicializls
    String image;                                           //httrkp fjlneve

    if ((inText=getParameter("inText"))==null)
       inText="benne van a kurzor";                     //alaprtelmezett inText
    if ((outText=getParameter("outText"))==null)
       outText="nincs benn a kurzor";                  //alaprtelmezett outText
    text=outText;                                  //kezdetben kinn van a kurzor
    noUpdate=(getParameter("noUpdate"))!=null;
    offScreen=(getParameter("offScreen"))!=null;
    if (offScreen) {                              //offScreen buffer ltrehozsa
       imageBuffer=createImage(getSize().width, getSize().height);
       graphicsBuffer=imageBuffer.getGraphics();
       graphicsBuffer.setClip(0, 0, getSize().width, getSize().height);
    }
    if ((image=getParameter("background"))!=null) {
       background=getImage(getCodeBase(), image);
       prepareImage(background, this);                       //betlts indtsa
/************************************************* betlts vezrlse Thread-del
       Thread t=Thread.currentThread();                   //aktulis programszl
       while ((checkImage(background, this)&ALLBITS)!=ALLBITS) {
             try {t.sleep(100);                  //vrakozs amg nincs betltve
             } catch (InterruptedException e) {                           //hiba
               System.err.println("PaintTest: "+e);
               background=null;
             }
       }
*******************************/ // betlts vezrlse java.awt.MediaTracker-rel
       MediaTracker tracker=new MediaTracker(this);
       tracker.addImage(background, 0);                          //kp figyelse
       try {tracker.waitForID(0);                     //megvrni, mg betltdik
       } catch (Exception e) {System.err.println("PaintTest: "+e);}       //hiba
       if (tracker.isErrorID(0)) {                         //sikertelen betlts
          System.err.println("Hiba: "+(Image)tracker.getErrorsAny()[0]);
          background=null;
       }
    }
    addMouseListener(this);                     //egresemnyeket figyelni fogja
  }
  public void update(Graphics g) {
    if (noUpdate) paint(g);                     //egybl tirnytani a paint-re
    else super.update(g);                       //alaprtelmezs szerinti update
  }
  public void paint(Graphics g) {
    int actx, acty;                           //aktulis mozaikkocka koordinti
    Graphics actg;                                      //ide kell majd rajzolni
    FontMetrics fm;                                      //fontmret informcik

    if (offScreen) {                                        //offScreen rajzols
       actg=graphicsBuffer;
       actg.setColor(getBackground());                                  //trls
       actg.fillRect(0, 0, getSize().width, getSize().height);
       actg.setColor(getForeground());
    } else actg=g;                                         //kpernyre rajzols
    if (background!=null) {acty=0;                               //van httrkp
       while (acty<getSize().height) {actx=0;                     //kimozaikozs
             while (actx<getSize().width) {
                   actg.drawImage(background, actx, acty, this);
                   actx+=background.getWidth(this);
             } acty+=background.getHeight(this);
       }
    }                                        //kirand szveg kzpre helyezse
    fm=g.getFontMetrics();                                         //lekrdezse
    if (fm!=null) {
       actx=(int)(getSize().width-fm.stringWidth(text))/2;
       acty=(int)(getSize().height-fm.getHeight())/2+fm.getAscent();
       actg.drawString(text, actx, acty);                       //szveg kirsa
    }
    if (offScreen) g.drawImage(imageBuffer, 0, 0, this);    //offScreen rajzols
  }
  public void mouseEntered(MouseEvent evt) {                      //kurzor belp
    text=inText; repaint();                         //a benti szveg az aktulis
  }
  public void mouseExited(MouseEvent evt) {                       //kurzor kilp
    text=outText; repaint();                        //a kinti szveg az aktulis
  }
  public void mousePressed(MouseEvent evt) {};                   //MouseListener
  public void mouseReleased(MouseEvent evt) {};                      //interfsz
  public void mouseClicked(MouseEvent evt) {};                  //miatt kellenek
}
