public class Alkalmazott {
    String nev;
    private int fizetes;
    private int evesFizetes;

    static int nyugdijKorhatar = 60;   // ltalnos nyugdjkorhatr
    int eletkor;                       // letkor szemlyenknt

    static int[] evesSzabadsag = new int [60];
    static {
        for (int i = 0; i < 30; i++)
            evesSzabadsag[i] = 15;
        for (int i = 30; i < 40; i++)
            evesSzabadsag[i] = evesSzabadsag[i-1] + 1;
        for (int i = 40; i < 50; i++)
            evesSzabadsag[i] = evesSzabadsag[i-1] + 2;
        for (int i = 50; i < 60; i++)
            evesSzabadsag[i] = evesSzabadsag[i-1] + 1;
    }

    int nyelvekSzama;

    public Alkalmazott(String nev, int fizetes) {
        this.nev = nev;
        this.fizetes = fizetes;
        this.evesFizetes = 12*fizetes;
    }
    public Alkalmazott(String nev) {
        this.nev = nev;
        this.fizetes = 40000;
        this.evesFizetes = 12*fizetes;
    }

    boolean tobbetKeresMint(Alkalmazott masik) {
        return fizetes > masik.fizetes;
    }
    boolean kevesebbetKeresMint(Alkalmazott masik) {
        return masik.tobbetKeresMint(this);
    }
    boolean kozepesJovedelmu(int minimum, int maximum) {
        return minimum <= fizetes && fizetes <= maximum;
    }
    void fizetestDuplaz() {
        fizetes *= 2;
    }
    void automatikusFizetesEmeles() {
        if (kozepesJovedelmu(30000, 60000)) fizetestEmel(5000);
    }
    void fizetestEmel(int novekmeny) {
        fizetes += novekmeny;
    }
    void fizetestEmel() {
        fizetes += 5000;
    }
    void fizetestEmel(Alkalmazott masik) {
        if (kevesebbetKeresMint(masik)) fizetes = masik.fizetes;
    }
    void ujFizetes(int osszeg) {
        fizetes = osszeg;
        evesFizetes = 12*osszeg;
    }
    public int fizetes() {
       return fizetes;
    }
    public int evesFizetes() {
       return evesFizetes;
    }

    int hatraVan() {                   // ennyi vet kell meg dolgozni
        return nyugdijKorhatar - eletkor;
    }
    static void nyugdijKorhatartEmel() {
        nyugdijKorhatar++;
    }

    public int evesSzabadsag() {
        if (eletkor < 60)
            return evesSzabadsag[eletkor];
        else
            return evesSzabadsag[59];
    }

    public int potlek() {
        return nyelvekSzama*5000;
    }
    public int fizetesPotlekokkal() {
        return fizetes() + potlek();
    }
}

class Fonok extends Alkalmazott {
    final int MAXBEOSZT = 20;
    Alkalmazott[] beosztottak = new Alkalmazott[MAXBEOSZT];
    int beosztottakSzama = 0;

    public Fonok(String nev, int fizetes) {
        super(nev, fizetes);
    }
    public Fonok(String nev) {
        this(nev, 100000);
    }

    public void ujBeosztott(Alkalmazott b) {
        beosztottak[beosztottakSzama++] = b;
    }

    public int potlek() {
        return super.potlek() + beosztottakSzama*1000;
    }
}
