interface Feltetel {
    public boolean teljesul(Object adat);
}

public class Lista {
    private Elem elso;

    public class Elem {
        public Object adat;
        Elem elozo, kovetkezo;

        public Elem(Object adat) {
            this.adat = adat;
            kovetkezo = elso;
            if (kovetkezo != null)
                kovetkezo.elozo = this;
            elso = this;
        }
        public void torol() {
            if (elozo != null)
                elozo.kovetkezo = kovetkezo;
            if (kovetkezo != null)
                kovetkezo.elozo = elozo;
            if (elso == this)
                elso = kovetkezo;
        }
    }
    public void beszur(Object adat) {
        new Elem(adat);
    }
    public void torol(Object adat) {
        Elem elem=keres(adat);
        if (elem != null) elem.torol();
    }
    public Elem keres(Object adat) {
        for (Elem elem = elso; elem != null; elem = elem.kovetkezo)
            if (elem.adat.equals(adat))
                return elem;
        return null;
    }
    public Elem keres(Feltetel feltetel) {
        for (Elem elem = elso; elem != null; elem = elem.kovetkezo)
            if (feltetel.teljesul(elem.adat))
                return elem;
        return null;
    }
    public Feltetel tartalmaz() {
        return new Feltetel() {
            public boolean teljesul(Object adat)
                { return keres(adat) != null; }
        };
    }
    public static Feltetel tombElemeFeltetel(final Object[] tomb) {
        class TombElemeFeltetel implements Feltetel {
            public boolean teljesul(Object adat) {
                for (int i = 0; i < tomb.length; i++)
                    if (tomb[i].equals(adat))
                        return true;
                return false;
            }
        }
        return new TombElemeFeltetel();
    }
}

class ArvaElem extends Lista.Elem {
    public ArvaElem(Lista potszulo, Object adat) {
        potszulo.super(adat);
    }
}
