import java.io.*;

class NotExpectedTokenException extends Exception {
  public int token;
  public NotExpectedTokenException( int token ){ this.token=token; }
}

public class TypedReader extends FilterReader {
  public TypedReader( Reader in ){ super(in); }
  public int scanInt() throws NotExpectedTokenException, IOException {
    StreamTokenizer st = new StreamTokenizer(in);
    st.ordinaryChar('/');      // nincs megjegyzsjel
    st.ordinaryChar('.');      // ne legyen tizedespont
    st.nextToken();
    if ( (st.ttype==StreamTokenizer.TT_NUMBER) && 
         (st.nval>=Integer.MIN_VALUE) && (st.nval<=Integer.MAX_VALUE) )
            return (int)st.nval;      // sikerlt szmknt rtelmezni
    else    throw new NotExpectedTokenException(st.ttype);
  }
  public static void main( String[] args ) throws Exception {
    TypedReader in = new TypedReader(new InputStreamReader(System.in));
    int sum = 0;
    boolean endOfInts = false; 
    while (!endOfInts) {
      try{ sum += in.scanInt();
      }catch (NotExpectedTokenException e){ endOfInts=true; }
    }
    System.out.println("Az sszeg: " + sum);
  }
}
