/*
 * CoClTest.java -- Egy sszekttets alap kliens alkalmazs
 *
 * Ez az alkalmazs felveszi az argumentumaiban megadott nev szmtgp
 * megadott sorszm TCP portjval a kapcsolatot, s tkld oda egy
 * pozitv numerikus rtket, amit a szerver feldolgoz (a jelenlegi
 * szerver implementci egyszeren ngyzetre emeli), s visszakldi a
 * kapott eredmnyt.
 *
 * A programparamterek:
 *
 *  Els    : annak a gpnek a neve, ahol a szerver fut
 *  Msodik : a szerver TCP portjnak a sorszma
 *  Harmadik: a szervernek tkldend szm (ezt emeli ngyzetre)
 *
 * Egy plda a futtatsra:
 *
 *  java CoClTest localhost 5678 56
 */

import java.io.*;
import java.net.*;

public class CoClTest {
  public static int ATKULDENDO_ERTEK ;

  public static void hasznalati_utasitas() {
      System.out.println("Hasznlat: java CoClTest " +
                         "szmtgpnv portsorszm szm");
      System.exit(-1);
  }

  public static void main(String[] args) {
    int server_port = 0;
    Socket s = null;
    String valasz = null;

    if (args.length != 3) hasznalati_utasitas();

    try { server_port = Integer.parseInt(args[1]); }
      catch (NumberFormatException e) { hasznalati_utasitas(); }
    try { ATKULDENDO_ERTEK = Integer.parseInt(args[2]); }
      catch (NumberFormatException e) { hasznalati_utasitas(); }

    try {
      /* Ltrehozzuk a kommunikcis vgpontunkat */
      s = new Socket(args[0], server_port);
      /* Ezzel tudunk a kommunikcis vgpontunkrl adatot olvasni: */
      BufferedReader input = new BufferedReader(
          new InputStreamReader(s.getInputStream()));
      /* Ezzel tudunk a kommunikcis vgpontunkra adatot rni: */
      PrintWriter output = new PrintWriter(s.getOutputStream());

      output.println(Integer.toString(ATKULDENDO_ERTEK)); output.flush();
      // Elkldtk a szervernek
      valasz = input.readLine(); // Megvrjuk a szerver vlaszt

      // Kirjuk az eredmnyt
      System.out.println("A kvnt szm ngyzete: " + valasz + ".");

    } catch (IOException e) {
      System.err.println(e); // Kirtuk a hiba okt ...
    }
    finally { // Lezrjuk a kommunikcis vgponthoz tartoz socketot ...
      try { s.close(); } catch (Exception ex) {
        System.err.println("Nem tudom lezrni a kapcsolatot!");
        }
    }
  }
}
