//                                                                       //
//                  Kliens-szerver Demo, 1997.                           //
//                                                                       //
//            Ksztette: Fodor Szabina s Gulys Lszl                 //
//                                                                       //
//                                                                       //
// A demoprogram egy egyszer kliens-szerver alkalmazs. A szerver       //
// a felhasznl azonostsa (vagy az j felhasznl felvtele) utn     //
// kpes egy szvegfjl tovbbtsra, illetve annak megadsra, hogy    //
// ez a felhasznl lekrdezte-e mr az adott fjlt.                     //
//                                                                       //

//    Az alkalmazs szerver oldala
import java.net.*;
import java.io.*;
import java.util.*;

//  Az 'adatbzis'-szerver osztly
//  Vgtelen ciklusban figyeli a szmtgp 1234-es portjt
//  s kiszolglja az ott megjelen krseket. A kiszolgls
//  a ServerProtocol osztlyban lert protokoll alapjn 
//  trtnik.
class Server  {
    // Ltrehozzuk a felhasznlk (kezdetben res) tbljt.
    // Ez egy hashtbla lesz, melyben a NV alapjn lehet
    // az adatokat (jelsz, olvasta-e mr a fjlt) lekrdezni.
    // FIGYELEM!!! Ez egy egyszer plda, biztonsgi krdsekkel
    // nem foglalkozik, sem a felhasznlk adatainak trolsnl,
    // sem pedig a hlzati kommunikci szintjn!

    public    static Hashtable    Users    = new Hashtable();

    public static void main(String[] args)  {
        // A kapcsolat szerver felli oldala
        ServerSocket    serverSocket = null;
        boolean         listening    = true;
        // A fogadegysg ltrehozsa    
        try{ serverSocket = new ServerSocket(1234);
           } catch (IOException e)  {
                 System.err.println( "Nem sikerlt rcsatlakozni az " +
                          "1234-es portra: " + e.getMessage()  );
                 System.exit(1);
             }
        // Fciklus
        while (listening)  {
            Socket clientSocket = null;
            try{ // A soronkvetkez krs fogadsa 
                 // s a kiszolgl szl elindtsa
                 clientSocket = serverSocket.accept();
                 new ServerThread(clientSocket).start();
               } catch (IOException e)  {
                     System.out.println( "Feldolgozatlan krs az " + 
                             "1234-es porton: " + e.getMessage() );
                     continue;
                 }        
        }
        // Ez a szervert lezr rsz, mely ebben a pldban
        // sohasem kerl vgrehajtsra, de ltalban szksg van r.
        try{ serverSocket.close();
           } catch (IOException e)  {
                 System.err.println("Sikertelen kapcsolat-zrs: " + 
                          e.getMessage() );
             }
    }
}

//  A krseket kiszolgl szlak osztlya
//  A szerverrel prhuzamosan futva feldolgozza az ahhoz
//  rkezett krst a ServerProtocol osztlyban lert 
//  protokoll alapjn.
class ServerThread extends Thread  {
    // A klienssel kapcsolatot tart objektum
    private     Socket         socket     = null;   
    // A protokolt megvalst objektum
    private     ServerProtocol protocol   = new ServerProtocol(this);
    // A klienssel kapcsolatot tart kt csatorna (input- s output stream)
    private     BufferedReader is        = null;
    private     PrintWriter    os        = null;
    
    // Az objektum ltrehozsa. 
    ServerThread(Socket socket)  {
        super("ServerThread");
        this.socket = socket;
    }
    // A tnyleges feldolgozs. Tulajdonkppen az rkez zenetek
    // rtelmezse s feldolgozsa.
    public void run()  {
        try{ // A kommunikci csatorninak (input- s output stream) 
             // ltrehozsa            
             is = new BufferedReader(new InputStreamReader(
                        socket.getInputStream())   );
             os = new PrintWriter(socket.getOutputStream());
             // Segdvltozk
             String  inputLine = null;   // Az zenet aktulis sora
             boolean cont      = true;   // Folytassuk mg?
            
             logEvent("Sikeres kapcsolat.");            
             while (cont) {
                try{ // Beolvassa a kvetkez zenet-sort s
                     // generlja hozz a protokoll szerinti
                     // vlaszt. Ha cont hamis lesz, akkor 
                     // a krs feldolgozsa befejezdtt.
                     inputLine = is.readLine();
                     cont = protocol.nextAnswer(inputLine);
                   } // Jelezzk, ha hibs adatmezt (nv, jelsz) kaptunk
                     catch (NoSuchElementException e)  {
                         sendMsg("##EMPTY FIELD");
                         logEvent("res mez");
                   } // Jelezzk, ha rtelmezhetetlen zenetet kaptunk
                     catch (BadSyntaxException e)  {
                         sendMsg("##SYNTAX ERROR");
                         logEvent("Protokollon kvli zenet!");
                   } // Jelezzk a kapcsolat esetleges hibjt
                     catch (IOException e) {
                         logEvent("Adattviteli hiba");
                         cont = false;
                     }
             }     
             // A kapcsolat lezrsa                  
             if (os!=null) os.close();
             if (is!=null) is.close();
             if (socket!=null) socket.close();
             logEvent("Kapcsolat lezrva");
          } catch (IOException e)  {
               System.out.println("Rendszerhiba: olvassi/rsi hiba");
            }
    }
  // Az adott zenet tovbbtsa a kliensnek
    public void sendMsg(String message) {
        os.println(message); os.flush();        
    }
  // Az adott esemny logolsa
    public void logEvent(String message) {
        // Az aktulis idpont lekrdezse
        Calendar    actDate = Calendar.getInstance();
        // A rszletes dtum s id kirsa
        System.out.print(actDate.get(Calendar.YEAR) + ".");
        System.out.print((actDate.get(Calendar.MONTH)+1) + ".");
        System.out.print(actDate.get(Calendar.DATE) + ", ");
        System.out.print(actDate.get(Calendar.HOUR) + ":");
        System.out.print(actDate.get(Calendar.MINUTE) + ":");
        System.out.print(actDate.get(Calendar.SECOND) + "> ");
        // Az esemny kirsa, a kliens IP-szmnak megadsval
        System.out.println("["+socket.getInetAddress()+"] "+message); 
    }
}

//  A felhasznlrl trolt adatok osztlya
class User {
    // A trolt adatok: jelsz, olvasta-e mr
    private String     password    = null;
    private boolean  newMessage    = true;
    
  // Az adatmez ltrehozsa (csak jelszval!)
    public User(String password) { this.password = password; }
  // A jelsz ellenrzse
    public boolean isPassWord(String password) {
        return (this.password.compareTo(password) == 0);
    }
  // Az 'olvasta-e mr' mez lekrdezse
    public boolean isNew() { return newMessage; }
  // Az 'olvasta-e mr' mez lltsa
    public void setNew(boolean state) { newMessage = state; }
}

//  A kliens-szerver protokoll szerveroldali rsznek megvalstsa. 
//  A ltrehozsakor kapott referencia segtsgvel elri szljnek 
//  (ServerThread!) zenetkld s logol metdusait.

class ServerProtocol {
    // Referencia a szlre
    private ServerThread parent = null;

    // A kapcsolat llst rgzt segdvltozk
    private boolean hasUser  = false; // rkezett mr USER kulcssz?
    private boolean newUser  = true;  // j felhasznl?
    private boolean logged   = false; // A bejelentkezs megtrtnt mr?
    private User    user     = null;  // A bejelentkezett felhasznl adatai
    private String  userName = null;  // A bejelentkezett felhasznl neve

    // Segdvltozk az zenetek feldolgozshoz
    private StringTokenizer st = null; // a szavanknti olvasshoz        
    private String       token = null; 
    
  //     Az objektum ltrehozsa
    public ServerProtocol(ServerThread parent) { this.parent = parent; }
  //     Vlasz generlsa az adott sorhoz
    public boolean nextAnswer(String inputLine) 
               throws BadSyntaxException, NoSuchElementException {
        st = new StringTokenizer(inputLine); // A tokenizer inicializlsa    
        token = st.nextToken(); // Az els sz

        // A BYE parancs szlelse
        if (token.compareTo("BYE") == 0) return false;

        // A megfelel feldolgozrutin hvsa    
        if (token.compareTo("USER") == 0) answerUSER();
        else if (token.compareTo("PSWD") == 0) answerPSWD();
        else if (token.compareTo("ASK") ==  0) answerASK();
        else if (token.compareTo("GET") == 0)  answerGET();
        else throw new BadSyntaxException();
        return true;
    }                        
  //     A USER kulcssz feldolgozsa
    private void answerUSER() 
             throws BadSyntaxException, NoSuchElementException {
        // Volt mr?
        if (hasUser) throw new BadSyntaxException();
        // Ha nem, akkor
        else  {
            token = st.nextToken();    // A kvetkez sz
            // Van ilyen nev felhasznl?
            if (Server.Users.containsKey(token)) {
                 parent.sendMsg("##KNOWN");                                 
                 newUser = false;
            }
            else { // Ha nincs, akkor j felhasznl
                 parent.sendMsg("##NEW");
                 newUser = true;
            }
            hasUser  = true;   // Volt mr USER             
            userName = token;  // Megjegyezzk a felhasznl nevt
        }        
    }
  //     A PSWD kulcssz feldolgozsa
    private void answerPSWD() 
             throws BadSyntaxException, NoSuchElementException {
        // Volt mr USER kulcssz? Ha nem, akkor hiba...
        if (!hasUser) throw new BadSyntaxException();
        else { // Lekrdezzk a jelszt
            token = st.nextToken();
            // j felhasznlrl van sz?
            if (newUser) {
                user = new User(token); // Ltrehozzuk s troljuk
                Server.Users.put(userName,user);
                newUser = false;        // Mr nem j felhasznl
                logged = true;          // A bejelentkezs megtrtnt
                parent.sendMsg("##OK"); // Vlaszzenet s logols
                parent.logEvent("j felhasznl: " + userName);
            }
            else  {  // Ismert felhasznl
                // Lekrdezzk az adatait
                user = (User)Server.Users.get(userName);
                // Ellenrizzk a jelszavt
                if (user.isPassWord(token)) {
                    parent.sendMsg("##OK");
                    logged = true;
                    parent.logEvent("Sikeres bejelentkezs: " +userName);
                } else { 
                    parent.sendMsg("##BAD");
                    hasUser = false;
                    user = null;                
                    parent.logEvent("Sikertelen bejelentkezs: " +userName);
                }    
            }
        }              
    }
  //     Az ASK kulcssz feldolgozsa
    private void answerASK() throws BadSyntaxException {
        // A bejelentkezs megtrtnt mr?
        if (logged) {
            if (user.isNew()) // Az 'olvasta mr' mez lekrdezse
                parent.sendMsg("##YES");
            else parent.sendMsg("##NO");
        }
        else throw new BadSyntaxException();
    }
  //    A GET kulcssz feldolgozsa
    private void answerGET() throws BadSyntaxException {
        // A bejelentkezs megtrtnt mr?
        if (logged) {
            parent.logEvent("Adatlekrs: " + userName);  // Logols
            try{ // A fjl megnyitsa
                 BufferedReader file = new BufferedReader(new FileReader(
                                           "DATAFILE.TXT"));
                 String lineString;
                 parent.sendMsg("##START");   // A nyitzenet elkldse
                 // A fjl kldse soronknt 
                 lineString = file.readLine();
                 while (lineString != null) {
                     parent.sendMsg(lineString);     
                     lineString = file.readLine();
                 }
                 user.setNew(false); // Az 'olvasta mr' mez belltsa
               } // A fjl nem elrhet
                 catch (FileNotFoundException e) {
                     parent.sendMsg("##NOT FOUND"); 
                     parent.logEvent("Az adatllomny nem elrhet.");
                 } // A fjl soronkvetkez sornak olvassa nem sikerlt
                 catch (IOException e) {
                     parent.sendMsg("##READ ERROR");
                     parent.logEvent("Olvassi hiba: " + userName);
                 } finally {
                    parent.sendMsg("##STOP"); // A zrzenet elkldse
                   }
        } else throw new BadSyntaxException();
    }
}

//  Ezt a kivtelt a protokollfeldolgoz vltja ki,
//  ha a feldolgozand zenet nem megfelel szintaxis.
class BadSyntaxException extends Exception { }        
