//                                                                   //
//                   Kliens-szerver Demo, 1997.                      //
//                                                                   //
//            Ksztette: Fodor Szabina s Gulys Lszl             //
//                                                                   //
//                                                                   //
//    Kliens applet az egyszer kliens-szerver adatbzishoz, mely    //
//    mr ismeri az ltalunk definilt protokollt.                   //
//                                                                   //

//  Az alkalmazs kliens oldala
import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.net.*;
import java.io.*;

public class Client extends Applet implements ActionListener {
//  Vltozk definilsa
    // Szvegmezk
    private TextField nameField;  // A felhasznli nv beviteli mezje
    private TextField passField;  // A jelsz beviteli mezje
    private TextArea  infoField;  // A kliens tjkoztat mezje

    // Cimkk
    private Label     nameLabel;  // A nv cimkjje
    private Label     passLabel;  // A jelsz cimkje 
    private Label     infoLabel;  // A tjkoztatmez cimkje 
    
    // Nyomgombok
    private Button    logButton;  // A Ki/Bejelentkezs gombja

    // A hlzati kapcsolat felptshez szksges vltozk
    // A kapcsolatban rsztvev szerver megadsa
    private String      serverHost  = "localhost";
    private Socket    clientSocket  = null;    // A hlzati kapcsolat objektuma
    private PrintWriter         os  = null;    // A kapcsolattarts csatorni:
    private BufferedReader      is  = null;    // input- s outputstream

//  A felhasznli felletel kapcsolatos metdusok    
  // Az applet indtsa
    public void init()  {
        // A pakolsi stratgia ltrehozsa s belltsa
        GridBagLayout      gridbag     = new GridBagLayout();
        GridBagConstraints constraints = new GridBagConstraints();
        setFont(new Font("TimesRoman", Font.BOLD, 14));
        setLayout(gridbag);
        constraints.anchor  = GridBagConstraints.WEST;
        constraints.weighty = 0.0;

        // 'nv' cimke s szvegmez elksztse
        nameLabel = new Label("Nv : ", Label.LEFT);
        nameField = new TextField(20);
        constraints.gridwidth = 1;
        addFormComponent(gridbag, nameLabel, constraints);
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.fill      = GridBagConstraints.HORIZONTAL;
        addFormComponent(gridbag, nameField, constraints); 
        // 'jelsz' cimke s szvegmez elksztse
        passLabel = new Label("Jelsz : ", Label.LEFT);
        passField = new TextField(20);
        passField.setEchoChar('#');
        constraints.gridwidth = 1;
        constraints.fill      = GridBagConstraints.NONE;
        constraints.weightx   = 0.0;
        addFormComponent(gridbag, passLabel, constraints);
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.weightx   = 1.0;
        addFormComponent(gridbag, passField, constraints); 
        // 'zenetek' szvegmez elhelyezse
        infoLabel = new Label("zenetek:", Label.LEFT);
        infoField = new TextArea(5,40);
        infoField.setEditable(false);
        constraints.gridwidth = 1;
        constraints.weightx   = 0.0;
        constraints.weighty   = 0.1;
        constraints.fill      = GridBagConstraints.NONE;
        addFormComponent(gridbag, infoLabel, constraints);
        constraints.fill      = GridBagConstraints.HORIZONTAL;
        constraints.gridwidth = GridBagConstraints.REMAINDER;
        constraints.weightx   = 1.0;
        addFormComponent(gridbag, infoField, constraints);
 
        // A Ki/Bejelentkezs gomb elksztse
        logButton = new Button("BEJELENTKEZS");
        logButton.addActionListener(this);
        constraints.weightx   = 1.0;
        constraints.weighty   = 0.5;
        constraints.fill      = GridBagConstraints.BOTH;
        constraints.gridheight= GridBagConstraints.REMAINDER;        
        constraints.gridx     = 1;
        constraints.gridwidth = GridBagConstraints.REMAINDER;     
        addFormComponent(gridbag, logButton, constraints);
        resize(500, 350);    
    }
  // Segdeljrs a komponensek kpernyre helyezshez   
    private void addFormComponent( GridBagLayout grid, Component comp, 
                                   GridBagConstraints c )  {
        grid.setConstraints(comp, c);
        add(comp);
    }
  // Informci az appletrl
    public String getAppletInfo() {
        return "Az egyszer kliens-szerver demo kliens appletje, " +
               "amely mr ismeri az ltalunk definilt protokollt.";
    } 
  // Infromci az applet paramtereirl
    public String[][] getParameterInfo() { return null; } 
  // Esemnyek kezelse
    public void actionPerformed(ActionEvent event)  {
          // Melyik gomb volt? A megfelel kezeleljrs hvsa
          if (event.getSource() == logButton)  {
             log();
          } 
    }
  // Az applet lezrsa
    public void destroy() { // A kapcsolat lezrsa (amennyiben volt)
        if (clientSocket != null)      closeSocket();
    }     
  // Be- es kijelentkezs
    private void log()  {
        // Van mr mkd kapcsolat?   
        if (clientSocket == null)  {
            // Ha nem, akkor ltrehozzuk s bejelentkeznk 
            boolean ok = false; // Mg nem volt sikeres bejelentkezs
            // A rendszerzenetek trlse
            infoField.setText("");
            // A kapcsolat felptse
            try{ clientSocket = new Socket(serverHost, 1234);
                 os = new PrintWriter(clientSocket.getOutputStream());
                 is = new BufferedReader(new InputStreamReader(
                      clientSocket.getInputStream()));
               } catch (UnknownHostException e)  {
                     infoField.append("Ismeretlen szerver\n");
               } catch (IOException e)  {
                     infoField.append("A szerver nem elrhet\n");
                 }

            // Ha minden rendben, akkor folytatjuk
            if (clientSocket != null && is != null && os != null) {
                try{ // Bejelentkezs
                     ok = logOn();
                   } catch (EmptyFieldException e) {
                         infoField.append("Kitltetlen beviteli mez\n");
                   } catch (SystemErrorException e) {
                         infoField.append("Rendszerhiba: " +
                             e.getMessage() + "\n");
                   } catch (NullPointerException e) {
                         infoField.append("A kapcsolat megszakadt\n");
                     }

                // Sikeresen bejelentkeztnk?
                if (ok)   {
                    infoField.append("A bejelentkezs megtrtnt\n");  
                    // A 'Ki/Bejelentkezs' gomb szvegnek cserje
                    logButton.setLabel("KIJELENTKEZS");
                }
                // Ha nem, akkor lezrjuk a kapcsolatot
                else closeSocket();
            }
        }
        // Ha mr volt kapcsolat, akkor megprbljuk bezrni
        else
            try{ closeSocket();
               } catch (Exception e)  {
                     infoField.append("Nincs lezrhat kapcsolat\n");
                 }
    }
  // A kapcsolat lezrsa
    private void closeSocket() {
        try{ // A zrzenet elkldse a szerver fel
             os.println("BYE"); os.flush();
             os.close();   // A csatornk lezrsa
             is.close();
             clientSocket.close();    
           } catch (Exception e) {
                 infoField.append("Hiba a kapcsolat lezrsnl\n");
             } finally {
                // A kapcsolat vltozjnak trlse 
                // (ez alapjn dntjk el, hogy van-e l kapcsolat)
                clientSocket = null;
         
                // A 'Ki/Bejelentkezs gomb visszalltsa
                logButton.setLabel("BEJELENTKEZS");
         
                // A tjkoztat szveg kirsa    
                infoField.append("A kijelentkezs megtrtnt\n");        
              }
    }
  // Bejelentkezs a szerverre
    private boolean logOn() throws SystemErrorException, 
              NullPointerException, EmptyFieldException {
        String name = nameField.getText(); // A bevitt felhasznli nv
        String pass = passField.getText(); // A bevitt jelsz
        boolean  ok = false;               // Sikeres bejelentkezs?
        try{ // Az 'USER nv' parancs elkldse s a vlasz leolvassa
             os.println("USER " + name); os.flush();
             String fromServer = is.readLine();
             // A vlasz rtelmezse
             if (fromServer.compareTo("##NEW") == 0) {
                 // j felhasznl
                 infoField.append("j felhasznl\n");
                 // Elkldjk a jelszavt is a 'PSWD jelsz'                   
                 // paranccsal s leolvassuk a vlaszt
                 os.println("PSWD " + pass); os.flush();
                 fromServer = is.readLine();     
                 // Ha valamilyen hibazenet jtt, akkor tovbbadjuk,
                 // hogy jelezhessk a felhasznlnak
                 if (fromServer.compareTo("##EMPTY FIELD") == 0) 
                     throw new EmptyFieldException();
                 else if (fromServer.compareTo("##OK") != 0) 
                     throw new SystemErrorException(1);                   
                 ok = true;   // Sikeres bejelentkezs
             } 
             // Ha valamilyen hibazenet jtt, akkor tovbbadjuk,
             // hogy jelezhessk a felhasznlnak
             else if (fromServer.compareTo("##EMPTY FIELD") == 0) 
                 throw new EmptyFieldException();
             else if (fromServer.compareTo("##KNOWN") != 0) 
                 throw new SystemErrorException(2);
             else { // Ha nincs hiba s nem j felhasznl, akkor 
                    // jelszellenrzs is lesz. Elkldjk a jelszt 
                    // a 'PSWD jelsz' paranccsal s leolvassuk a vlaszt
                 os.println("PSWD " + pass); os.flush();
                 fromServer = is.readLine();
                 // Helyes jelsz volt?
                 if (fromServer.compareTo("##OK") == 0) 
                 //Ha igen, akkor
                     ok = true; // Sikeres bejelentkezs
                 // Ha nem, akkor jelezzk
                 else if (fromServer.compareTo("##BAD") == 0) 
                     infoField.append("Rossz jelsz\n");  
                     // Ha res jelsz volt, akkor tovbbtjuk az zenetet
                 else if (fromServer.compareTo("##EMPTY FIELD") == 0) 
                     throw new EmptyFieldException();
                 // Ha egyb zenet jtt, akkor a kommunikcis
                 // csatorna vagy a szerver srlt
                 else throw new SystemErrorException(3);
             }             
           } // Ha nem tudtunk olvasni a csatornrl, akkor
             // a kommunikcis csatorna srlt
             catch (IOException e) {
                 throw new SystemErrorException(4);               
             }
        return ok;  // Visszaadjuk, hogy volt-e sikeres bejelentkezs
    }
  // j zenet ltnek lekrdezse
    private boolean isNewMessage() throws SystemErrorException {
        try{ // Az 'ASK' zenet elkldse s a vlasz leolvassa
             os.println("ASK"); os.flush();
             String fromServer = is.readLine();
             // Ha '##YES' vagy '##NO' jtt, akkor rtelmezzk
             if ( (fromServer.compareTo("##YES") == 0) ||
                    (fromServer.compareTo("##NO") == 0) )  {
                 // rtelmezzk a vlaszt s tovbbadjuk az eredmnyt
                 return (fromServer.compareTo("##YES") == 0);        
             }
             // Ha ms zenet jtt, akkor a kommunikcis 
             // csatorna, vagy a szerver srlt
             else throw new SystemErrorException(5);
           } // Ha nem tudunk olvasni, a kommunikcis csatorna srlt
             catch (IOException e) {
                 throw new SystemErrorException(6);
             }
    }
  // Az zenetlekrdezs megvalstsa
    private void handleMessage() {
        // A szervertl kapott zenet egy sora
        String fromServer;
        try{ // A 'GET' zenet elkldse s a vlasz leolvassa
             os.println("GET"); os.flush();            
             fromServer = is.readLine();
             // Ha hibazenet, akkor jelezzk 
             if (fromServer.compareTo("##NOT FOUND") == 0) 
                 infoField.append("Szerver hiba: az adatllomny " +
                         "nem elrhet.\n");
             // Ha nem a vrt zenet, akkor a kommunikcis
             // csatorna vagy a szerver srlt            
             else if (fromServer.compareTo("##START") != 0) 
                 throw new SystemErrorException(7);
             // Ha elkezddtt a szerver adsa, akkor fogadjuk
             else { // Az els sor fogadsa
                 fromServer = is.readLine();
                 // Amg nem lezrs, addig olvasunk
                 while (fromServer.compareTo("##STOP") != 0)   {
                     // Ha hibs adat jtt, akkor jelezzk
                     if (fromServer.compareTo("##READ ERROR") == 0)
                         infoField.append("Olvassi hiba " +
                                 "a szerveren\n");
                     // A kvetkez sor olvassa
                     fromServer = is.readLine();    
                 }
             }
           } // Ha nem tudtunk olvasni, jelezzk s lezrjuk a kapcsolatot
             catch (NullPointerException e) {
                infoField.append("A kapcsolat megszakadt\n");
                closeSocket();
           } catch (IOException e) {
                infoField.append("A kapcsolat megszakadt\n");
                closeSocket();
           } // Ha rendszerhiba volt, akkor jelezzk            
             catch (SystemErrorException e) {
             infoField.append("Rendszerhiba: " + e.getMessage() + "\n");
             closeSocket();
             }        
    }
}

//  A 'Rendszerhiba' kivtel definilsa
class SystemErrorException extends Exception {
    // A kivtel ltrehozsa, a megadott sorszmmal
    public SystemErrorException(int i) {
        // A sorszm szvegg konvertlsa s tovbbadsa
        super(Integer.toString(i));
    }
}

//  Az 'res mez' kivtel definilsa
class EmptyFieldException extends Exception {}        
